/* This file replaces MAKES.H from Jaroslaw Wroblewski's AP26 sample
   implementation. The only changes are to use int64_t instead of long long,
   and to replace expressions (j*STEP)%X with (j*(STEP%X))%X.
*/
#define MAKE_OK(_X) \
  for(j=0;j<_X;j++) \
    OK##_X[j]=1; \
  for(j=(_X-23);j<=_X;j++) \
    OK##_X[(j*(STEP%_X))%_X]=0;

#if ASM && FPU
/* The floating point assembly works with remainders in the range 0<=j<=_P,
   so we add a copy of the first element to the end of arrays 101-331.
*/
#define MAKE_OKOK(_X) \
  for(j=0;j<_X;j++) \
    OKOK##_X[j]=0; \
  for(j=0;j<_X;j++) \
    for(jj=0;jj<64;jj++) \
      OKOK##_X[j]|=(((int64_t)OK##_X[(j+(jj+SHIFT)*MOD)%_X])<<jj); \
  if (_X >= 101) \
    OKOK##_X[_X]=OKOK##_X[0];
#else
#define MAKE_OKOK(_X) \
  for(j=0;j<_X;j++) \
    OKOK##_X[j]=0; \
  for(j=0;j<_X;j++) \
    for(jj=0;jj<64;jj++) \
      OKOK##_X[j]|=(((int64_t)OK##_X[(j+(jj+SHIFT)*MOD)%_X])<<jj);
#endif

MAKE_OK(61);
MAKE_OK(67);
MAKE_OK(71);
MAKE_OK(73);
MAKE_OK(79);
MAKE_OK(83);
MAKE_OK(89);
MAKE_OK(97);
MAKE_OK(101);
MAKE_OK(103);
MAKE_OK(107);
MAKE_OK(109);
MAKE_OK(113);
MAKE_OK(127);
MAKE_OK(131);
MAKE_OK(137);
MAKE_OK(139);
MAKE_OK(149);
MAKE_OK(151);
MAKE_OK(157);
MAKE_OK(163);
MAKE_OK(167);
MAKE_OK(173);
MAKE_OK(179);
MAKE_OK(181);
MAKE_OK(191);
MAKE_OK(193);
MAKE_OK(197);
MAKE_OK(199);
MAKE_OK(211);
MAKE_OK(223);
MAKE_OK(227);
MAKE_OK(229);
MAKE_OK(233);
MAKE_OK(239);
MAKE_OK(241);
MAKE_OK(251);
MAKE_OK(257);
MAKE_OK(263);
MAKE_OK(269);
MAKE_OK(271);
MAKE_OK(277);
MAKE_OK(281);
MAKE_OK(283);
MAKE_OK(293);
MAKE_OK(307);
MAKE_OK(311);
MAKE_OK(313);
MAKE_OK(317);
MAKE_OK(331);
MAKE_OK(337);
MAKE_OK(347);
MAKE_OK(349);
MAKE_OK(353);
MAKE_OK(359);
MAKE_OK(367);
MAKE_OK(373);
MAKE_OK(379);
MAKE_OK(383);
MAKE_OK(389);
MAKE_OK(397);
MAKE_OK(401);
MAKE_OK(409);
MAKE_OK(419);
MAKE_OK(421);
MAKE_OK(431);
MAKE_OK(433);
MAKE_OK(439);
MAKE_OK(443);
MAKE_OK(449);
MAKE_OK(457);
MAKE_OK(461);
MAKE_OK(463);
MAKE_OK(467);
MAKE_OK(479);
MAKE_OK(487);
MAKE_OK(491);
MAKE_OK(499);
MAKE_OK(503);
MAKE_OK(509);
MAKE_OK(521);
MAKE_OK(523);
MAKE_OK(541);

MAKE_OKOK(61);
MAKE_OKOK(67);
MAKE_OKOK(71);
MAKE_OKOK(73);
MAKE_OKOK(79);
MAKE_OKOK(83);
MAKE_OKOK(89);
MAKE_OKOK(97);
MAKE_OKOK(101);
MAKE_OKOK(103);
MAKE_OKOK(107);
MAKE_OKOK(109);
MAKE_OKOK(113);
MAKE_OKOK(127);
MAKE_OKOK(131);
MAKE_OKOK(137);
MAKE_OKOK(139);
MAKE_OKOK(149);
MAKE_OKOK(151);
MAKE_OKOK(157);
MAKE_OKOK(163);
MAKE_OKOK(167);
MAKE_OKOK(173);
MAKE_OKOK(179);
MAKE_OKOK(181);
MAKE_OKOK(191);
MAKE_OKOK(193);
MAKE_OKOK(197);
MAKE_OKOK(199);
MAKE_OKOK(211);
MAKE_OKOK(223);
MAKE_OKOK(227);
MAKE_OKOK(229);
MAKE_OKOK(233);
MAKE_OKOK(239);
MAKE_OKOK(241);
MAKE_OKOK(251);
MAKE_OKOK(257);
MAKE_OKOK(263);
MAKE_OKOK(269);
MAKE_OKOK(271);
MAKE_OKOK(277);
MAKE_OKOK(281);
MAKE_OKOK(283);
MAKE_OKOK(293);
MAKE_OKOK(307);
MAKE_OKOK(311);
MAKE_OKOK(313);
MAKE_OKOK(317);
MAKE_OKOK(331);
