/* This file replaces SITO.H from Jaroslaw Wroblewski's AP26 sample
   implementation. Changes are contained between the __GNUC__ and FASTER32
   conditionals.

   Modified for SSE2 support 27 September 2009 by Bryan Little

   For GCC, __builtin_expect(EXP,C) means that EXP is predicted to evaluate
   to C. Other compilers will surely have a different way to do this, and so
   it is only used when __GNUC__ is defined.
*/

#ifdef __GNUC__
# define UNLIKELY(_EXP) __builtin_expect((_EXP)!=0,0)
#else
# define UNLIKELY(_EXP) (_EXP)
#endif

// Bryan Little, new fast vectors for loop
// integers are stored IN REVERSE ORDER in SSE2!
if(UNLIKELY(sito = OKOK61[_mm_extract_epi16(r_numvec1, 7)]
                 & OKOK67[_mm_extract_epi16(r_numvec1, 6)]
                 & OKOK71[_mm_extract_epi16(r_numvec1, 5)]
                 & OKOK73[_mm_extract_epi16(r_numvec1, 4)]
                 & OKOK79[_mm_extract_epi16(r_numvec1, 3)]
                 & OKOK83[_mm_extract_epi16(r_numvec1, 2)]
                 & OKOK89[_mm_extract_epi16(r_numvec1, 1)]
                 & OKOK97[_mm_extract_epi16(r_numvec1, 0)]))
if(UNLIKELY(sito&=(OKOK101[_mm_extract_epi16(r_numvec2, 7)]
                 & OKOK103[_mm_extract_epi16(r_numvec2, 6)]
                 & OKOK107[_mm_extract_epi16(r_numvec2, 5)]
                 & OKOK109[_mm_extract_epi16(r_numvec2, 4)]
		 & OKOK113[_mm_extract_epi16(r_numvec2, 3)]
                 & OKOK127[_mm_extract_epi16(r_numvec2, 2)]
                 & OKOK131[_mm_extract_epi16(r_numvec2, 1)]
                 & OKOK137[_mm_extract_epi16(r_numvec2, 0)])))
if(UNLIKELY(sito&=(OKOK139[REM(n59,139,8)]
		 & OKOK149[REM(n59,149,8)]
                 & OKOK151[REM(n59,151,8)]
                 & OKOK157[REM(n59,157,8)]
                 & OKOK163[REM(n59,163,8)]
                 & OKOK167[REM(n59,167,8)]
                 & OKOK173[REM(n59,173,8)]
                 & OKOK179[REM(n59,179,8)]
                 & OKOK181[REM(n59,181,8)]
                 & OKOK191[REM(n59,191,8)]
                 & OKOK193[REM(n59,193,8)])))
if(UNLIKELY(sito&=(OKOK197[REM(n59,197,8)]
                 & OKOK199[REM(n59,199,8)]
                 & OKOK211[REM(n59,211,8)]
                 & OKOK223[REM(n59,223,8)]
                 & OKOK227[REM(n59,227,8)]
                 & OKOK229[REM(n59,229,8)]
                 & OKOK233[REM(n59,233,8)]
                 & OKOK239[REM(n59,239,8)]
                 & OKOK241[REM(n59,241,8)]
                 & OKOK251[REM(n59,251,8)]
                 & OKOK257[REM(n59,257,9)])))
if(UNLIKELY(sito&=(OKOK263[REM(n59,263,9)]
                 & OKOK269[REM(n59,269,9)]
                 & OKOK271[REM(n59,271,9)]
                 & OKOK277[REM(n59,277,9)]
                 & OKOK281[REM(n59,281,9)]
                 & OKOK283[REM(n59,283,9)]
                 & OKOK293[REM(n59,293,9)]
                 & OKOK307[REM(n59,307,9)]
                 & OKOK311[REM(n59,311,9)]
                 & OKOK313[REM(n59,313,9)]
                 & OKOK317[REM(n59,317,9)]
                 & OKOK331[REM(n59,331,9)])))

